diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/manual/Makefile ns-3.36/doc/manual/Makefile
--- ns-3.35/doc/manual/Makefile	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/doc/manual/Makefile	2022-04-30 18:23:57.646732600 -0700
@@ -16,11 +16,12 @@
 	source/replace.txt \
 	source/attributes.rst \
 	source/callbacks.rst \
-	source/working-with-git.rst \
+	source/develop.rst \
 	source/documentation.rst \
 	source/enable-modules.rst \
 	source/enable-tests.rst \
 	source/events.rst \
+	source/features.rst \
 	source/gnuplot.rst \
 	source/hash-functions.rst \
 	source/helpers.rst \
@@ -31,9 +32,11 @@
 	source/object-model.rst \
 	source/object-names.rst \
 	source/organization.rst \
+	source/profiling.rst \
 	source/python.rst \
 	source/random-variables.rst \
 	source/realtime.rst \
+	source/simulator.rst \
 	source/support.rst \
 	source/test-background.rst \
 	source/test-framework.rst \
@@ -42,6 +45,9 @@
 	source/tracing.rst \
 	source/troubleshoot.rst \
 	source/utilities.rst \
+	source/working-with-cmake.rst \
+	source/working-with-git.rst \
+	source/working-with-gitlab-ci-local.rst \
 	${SRC}/stats/doc/data-collection.rst \
 	${SRC}/stats/doc/data-collection-overview.rst \
 	${SRC}/stats/doc/statistics.rst \
@@ -60,18 +66,35 @@
 #  3) both a .pdf and .png file
 
 SOURCEFIGS = \
-        figures/software-organization.dia \
+    figures/software-organization.dia \
 	figures/plot-2d.png \
 	figures/plot-2d-with-error-bars.png \
 	figures/plot-3d.png \
 	figures/gtk-config-lena-dual-stripe-device-view.png \
 	figures/gtk-config-lena-dual-stripe-eNB-tx-power.png \
+	figures/heaptrack.png \
+	figures/hotspot-cycles.png \
+	figures/hotspot-setup.png \
+	figures/hotspot-top-down.png \
+	figures/perfetto-trace-cmake.png \
+	figures/uprof-collect-callstack.png \
+	figures/uprof-collect-callstack.png \
+	figures/uprof-profile-application.png \
+	figures/uprof-select-events.png \
+	figures/uprof-start.png \
+	figures/uprof-stats.png \
+	figures/uprof-strace-lte.png \
+	figures/vtune-configure.png \
+	figures/vtune-landing.png \
+	figures/vtune-perf-snapshot.png \
+	figures/vtune-select-uarch-profiling.png \
+	figures/vtune-uarch-core-stats.png \
+	figures/vtune-uarch-profiling-summary.png \
+	figures/vtune-uarch-wifi-stats.png \
 	${SRC}/stats/doc/Stat-framework-arch.png \
 	${SRC}/stats/doc/Wifi-default.png \
 	${SRC}/stats/doc/dcf-overview.dia \
 	${SRC}/stats/doc/dcf-overview-with-aggregation.dia \
-	${SRC}/stats/doc/gnuplot-example.png \
-	${SRC}/stats/doc/file-example.png \
 	${SRC}/stats/doc/seventh-packet-byte-count.png \
 	${SRC}/stats/doc/gnuplot-helper-example.png \
 	${SRC}/stats/doc/gnuplot-aggregator.png \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/models/Makefile ns-3.36/doc/models/Makefile
--- ns-3.35/doc/models/Makefile	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/doc/models/Makefile	2022-04-30 18:23:57.682732800 -0700
@@ -76,6 +76,7 @@
 	$(SRC)/wifi/doc/source/wifi-design.rst \
 	$(SRC)/wifi/doc/source/wifi-user.rst \
 	$(SRC)/wifi/doc/source/wifi-testing.rst \
+	$(SRC)/wifi/doc/source/wifi-changelog.rst \
 	$(SRC)/wifi/doc/source/wifi-references.rst \
 	$(SRC)/wimax/doc/wimax.rst \
 	$(SRC)/uan/doc/uan.rst \
@@ -334,6 +335,7 @@
 	$(SRC)/netanim/doc/figures/RoutingTables.pdf \
 	$(SRC)/netanim/doc/figures/PacketTimeline.png \
 	$(SRC)/netanim/doc/figures/PacketTimeline.pdf \
+	$(SRC)/nix-vector-routing/doc/figures/nms.png \
 	$(SRC)/spectrum/doc/spectrum-channel-phy-interface.png \
 	$(SRC)/spectrum/doc/spectrum-channel-phy-interface.pdf \
 	$(SRC)/spectrum/doc/spectrum-analyzer-example.eps \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/ns3_html_theme/get_version.sh ns-3.36/doc/ns3_html_theme/get_version.sh
--- ns-3.35/doc/ns3_html_theme/get_version.sh	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/doc/ns3_html_theme/get_version.sh	2022-04-30 18:23:57.686732800 -0700
@@ -27,7 +27,7 @@
 #     run by cron jobs.)
 #
 # If both a and b are true, we're building for public urls.
-# (The newer update-docs script (through waf) sets
+# (The newer update-docs script (through ns3) sets
 # NS3_WWW_URLS=public explicitly.)
 # 
 # The repo version is either a tag name or a commit (short) id.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/ns3_html_theme/static/drop-down-menu.js ns-3.36/doc/ns3_html_theme/static/drop-down-menu.js
--- ns-3.35/doc/ns3_html_theme/static/drop-down-menu.js	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/doc/ns3_html_theme/static/drop-down-menu.js	2022-04-30 18:23:57.686732800 -0700
@@ -1,5 +1,34 @@
 // Copyright 2006-2007 javascript-array.com
 // http://javascript-array.com/scripts/simple_drop_down_menu/
+//
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are
+// met:
+// 
+//     (1) Redistributions of source code must retain the above copyright
+//     notice, this list of conditions and the following disclaimer. 
+// 
+//     (2) Redistributions in binary form must reproduce the above copyright
+//     notice, this list of conditions and the following disclaimer in
+//     the documentation and/or other materials provided with the
+//     distribution.  
+//     
+//     (3) The name of the author may not be used to
+//     endorse or promote products derived from this software without
+//     specific prior written permission.
+// 
+// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+// IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+// POSSIBILITY OF SUCH DAMAGE. 
+// 
 
 var timeout	= 250;
 var closetimer	= 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/ns3_html_theme/static/ns3_links.js ns-3.36/doc/ns3_html_theme/static/ns3_links.js
--- ns-3.35/doc/ns3_html_theme/static/ns3_links.js	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/doc/ns3_html_theme/static/ns3_links.js	2022-04-30 18:23:57.686732800 -0700
@@ -3,6 +3,7 @@
 var ns3_home = ns3_site + "";
 var ns3_wiki = ns3_site + "wiki";
 var ns3_bugs = "https://gitlab.com/nsnam/ns-3-dev/-/issues";
+var ns3_merge = "https://gitlab.com/nsnam/ns-3-dev/-/merge_requests";
 
 // Links that depend on version:
 // Defined in ns3_version.js:
@@ -42,15 +43,17 @@
 var ns3_man  = ns3_rel  + "manual/"         + ns3_index;
 var ns3_mod  = ns3_rel  + "models/"         + ns3_index;
 var ns3_tut  = ns3_rel  + "tutorial/"       + ns3_index;
+var ns3_con  = ns3_rel  + "contributing/"   + ns3_index;
 
 function ns3_write_links() {
   document.getElementById("ns3_home1").href = ns3_home;
   document.getElementById("ns3_home2").href = ns3_home;
-  document.getElementById("ns3_wiki" ).href = ns3_wiki;
-  document.getElementById("ns3_bugs" ).href = ns3_bugs;
-  
-  document.getElementById("ns3_api"  ).href = ns3_api;
+  document.getElementById("ns3_tut"  ).href = ns3_tut;
   document.getElementById("ns3_man"  ).href = ns3_man;
   document.getElementById("ns3_mod"  ).href = ns3_mod;
-  document.getElementById("ns3_tut"  ).href = ns3_tut;
+  document.getElementById("ns3_con"  ).href = ns3_con;
+  document.getElementById("ns3_wiki" ).href = ns3_wiki;
+  document.getElementById("ns3_api"  ).href = ns3_dox;
+  document.getElementById("ns3_bugs" ).href = ns3_bugs;
+  document.getElementById("ns3_merge").href = ns3_merge;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/channel-models/CMakeLists.txt ns-3.36/examples/channel-models/CMakeLists.txt
--- ns-3.35/examples/channel-models/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/channel-models/CMakeLists.txt	2022-04-30 18:23:57.718732800 -0700
@@ -0,0 +1,11 @@
+build_example(
+  NAME three-gpp-v2v-channel-example
+  SOURCE_FILES three-gpp-v2v-channel-example.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libmobility}
+    ${libpropagation}
+    ${libspectrum}
+    ${libantenna}
+    ${libbuildings}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/channel-models/three-gpp-v2v-channel-example.cc ns-3.36/examples/channel-models/three-gpp-v2v-channel-example.cc
--- ns-3.35/examples/channel-models/three-gpp-v2v-channel-example.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/channel-models/three-gpp-v2v-channel-example.cc	2022-04-30 18:23:57.718732800 -0700
@@ -54,6 +54,42 @@
 static Ptr<ThreeGppSpectrumPropagationLossModel> m_spectrumLossModel; //!< the SpectrumPropagationLossModel object
 static Ptr<ChannelConditionModel> m_condModel; //!< the ChannelConditionModel object
 
+/*
+ * \brief A structure that holds the parameters for the ComputeSnr
+ * function. In this way the problem with the limited
+ * number of parameters of method Schedule is avoided.
+ */
+struct ComputeSnrParams
+{
+  Ptr<MobilityModel> txMob; //!< the tx mobility model
+  Ptr<MobilityModel> rxMob; //!< the rx mobility model
+  Ptr<SpectrumValue> txPsd; //!< the PSD of the tx signal
+  double noiseFigure; //!< the noise figure in dB
+  Ptr<PhasedArrayModel> txAntenna; //!< the tx antenna array
+  Ptr<PhasedArrayModel> rxAntenna; //!< the rx antenna array
+
+  /**
+   * \brief Constructor
+   * \param pTxMob the tx mobility model
+   * \param pRxMob the rx mobility model
+   * \param pTxPsd the PSD of the tx signal
+   * \param pNoiseFigure the noise figure in dB
+   * \param pTxAntenna the tx antenna array
+   * \param pRxAntenna the rx antenna array
+   */
+  ComputeSnrParams (Ptr<MobilityModel> pTxMob, Ptr<MobilityModel> pRxMob,
+                    Ptr<SpectrumValue> pTxPsd, double pNoiseFigure,
+                    Ptr<PhasedArrayModel> pTxAntenna, Ptr<PhasedArrayModel> pRxAntenna)
+  {
+    txMob = pTxMob;
+    rxMob = pRxMob;
+    txPsd = pTxPsd;
+    noiseFigure = pNoiseFigure;
+    txAntenna = pTxAntenna;
+    rxAntenna = pRxAntenna;
+  }
+};
+
 /**
  * Perform the beamforming using the DFT beamforming method
  * \param thisDevice the device performing the beamforming
@@ -78,36 +114,33 @@
 
 /**
  * Compute the average SNR
- * \param txMob the tx mobility model
- * \param rxMob the rx mobility model
- * \param txPsd the PSD of the transmitting signal
- * \param noiseFigure the noise figure in dB
+ * \param params A structure that holds a bunch of parameters needed by ComputSnr function to calculate the average SNR
  */
 static void
-ComputeSnr (Ptr<MobilityModel> txMob, Ptr<MobilityModel> rxMob, Ptr<const SpectrumValue> txPsd, double noiseFigure)
+ComputeSnr (ComputeSnrParams& params)
 {
-  Ptr<SpectrumValue> rxPsd = txPsd->Copy ();
+  Ptr<SpectrumValue> rxPsd = params.txPsd->Copy ();
 
   // check the channel condition
-  Ptr<ChannelCondition> cond = m_condModel->GetChannelCondition (txMob, rxMob);
+  Ptr<ChannelCondition> cond = m_condModel->GetChannelCondition (params.txMob, params.rxMob);
 
   // apply the pathloss
-  double propagationGainDb = m_propagationLossModel->CalcRxPower (0, txMob, rxMob);
+  double propagationGainDb = m_propagationLossModel->CalcRxPower (0, params.txMob, params.rxMob);
   NS_LOG_DEBUG ("Pathloss " << -propagationGainDb << " dB");
   double propagationGainLinear = std::pow (10.0, (propagationGainDb) / 10.0);
   *(rxPsd) *= propagationGainLinear;
 
   // apply the fast fading and the beamforming gain
-  rxPsd = m_spectrumLossModel->CalcRxPowerSpectralDensity (rxPsd, txMob, rxMob);
+  rxPsd = m_spectrumLossModel->CalcRxPowerSpectralDensity (rxPsd, params.txMob, params.rxMob, params.txAntenna, params.rxAntenna);
   NS_LOG_DEBUG ("Average rx power " << 10 * log10 (Sum (*rxPsd) * 180e3) << " dB");
 
   // create the noise psd
   // taken from lte-spectrum-value-helper
   const double kT_dBm_Hz = -174.0; // dBm/Hz
   double kT_W_Hz = std::pow (10.0, (kT_dBm_Hz - 30) / 10.0);
-  double noiseFigureLinear = std::pow (10.0, noiseFigure / 10.0);
+  double noiseFigureLinear = std::pow (10.0, params.noiseFigure / 10.0);
   double noisePowerSpectralDensity =  kT_W_Hz * noiseFigureLinear;
-  Ptr<SpectrumValue> noisePsd = Create <SpectrumValue> (txPsd->GetSpectrumModel ());
+  Ptr<SpectrumValue> noisePsd = Create <SpectrumValue> (params.txPsd->GetSpectrumModel ());
   (*noisePsd) = noisePowerSpectralDensity;
 
   // compute the SNR
@@ -117,10 +150,10 @@
   std::ofstream f;
   f.open ("example-output.txt", std::ios::out | std::ios::app);
   f << Simulator::Now ().GetSeconds () << " " // time [s]
-    << txMob->GetPosition ().x << " "
-    << txMob->GetPosition ().y << " "
-    << rxMob->GetPosition ().x << " "
-    << rxMob->GetPosition ().y << " "
+    << params.txMob->GetPosition ().x << " "
+    << params.txMob->GetPosition ().y << " "
+    << params.rxMob->GetPosition ().x << " "
+    << params.rxMob->GetPosition ().y << " "
     << cond->GetLosCondition () << " " // channel state
     << 10 * log10 (Sum (*rxPsd) / Sum (*noisePsd)) << " " // SNR [dB]
     << -propagationGainDb << std::endl; // pathloss [dB]
@@ -296,14 +329,10 @@
   channelModel->SetAttribute ("Scenario", StringValue (scenario));
   channelModel->SetAttribute ("Frequency", DoubleValue (frequency));
   channelModel->SetAttribute ("ChannelConditionModel", PointerValue (m_condModel));
+  channelModel->SetAttribute ("vScatt", DoubleValue (vScatt));
 
   // create the spectrum propagation loss model
   m_spectrumLossModel = CreateObjectWithAttributes<ThreeGppSpectrumPropagationLossModel> ("ChannelModel", PointerValue (channelModel));
-  m_spectrumLossModel->SetAttribute ("vScatt", DoubleValue (vScatt));
-
-  // initialize the devices in the ThreeGppSpectrumPropagationLossModel
-  m_spectrumLossModel->AddDevice (txDev, txAntenna);
-  m_spectrumLossModel->AddDevice (rxDev, rxAntenna);
 
   BuildingsHelper::Install (nodes);
 
@@ -332,7 +361,7 @@
 
   for (int i = 0; i < simTime / timeRes; i++)
     {
-      Simulator::Schedule (timeRes * i, &ComputeSnr, txMob, rxMob, txPsd, noiseFigure);
+      Simulator::Schedule (timeRes * i, &ComputeSnr, ComputeSnrParams (txMob, rxMob, txPsd, noiseFigure, txAntenna, rxAntenna));
     }
 
   // initialize the output file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/CMakeLists.txt ns-3.36/examples/CMakeLists.txt
--- ns-3.35/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/CMakeLists.txt	2022-04-30 18:23:57.718732800 -0700
@@ -0,0 +1,18 @@
+if(${ENABLE_EXAMPLES})
+  subdirlist(examples_to_build ${CMAKE_CURRENT_SOURCE_DIR})
+
+  # Process subdirectories
+  foreach(examplefolder ${examples_to_build})
+    if(NOT (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${examplefolder}/CMakeLists.txt))
+      continue()
+    endif()
+    add_subdirectory(${examplefolder})
+
+    set(ns3-example-folders
+        "${examplefolder};${ns3-example-folders}"
+        CACHE INTERNAL "list of example folders"
+    )
+  endforeach()
+endif()
+
+scan_python_examples(${CMAKE_CURRENT_SOURCE_DIR})
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/energy/CMakeLists.txt ns-3.36/examples/energy/CMakeLists.txt
--- ns-3.35/examples/energy/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/energy/CMakeLists.txt	2022-04-30 18:23:57.718732800 -0700
@@ -0,0 +1,23 @@
+build_example(
+  NAME energy-model-example
+  SOURCE_FILES energy-model-example.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libmobility}
+    ${libwifi}
+    ${libenergy}
+    ${libinternet}
+    ${libconfig-store}
+)
+
+build_example(
+  NAME energy-model-with-harvesting-example
+  SOURCE_FILES energy-model-with-harvesting-example.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libmobility}
+    ${libwifi}
+    ${libenergy}
+    ${libinternet}
+    ${libconfig-store}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/error-model/CMakeLists.txt ns-3.36/examples/error-model/CMakeLists.txt
--- ns-3.35/examples/error-model/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/error-model/CMakeLists.txt	2022-04-30 18:23:57.718732800 -0700
@@ -0,0 +1,8 @@
+build_example(
+  NAME simple-error-model
+  SOURCE_FILES simple-error-model.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/ipv6/CMakeLists.txt ns-3.36/examples/ipv6/CMakeLists.txt
--- ns-3.35/examples/ipv6/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/ipv6/CMakeLists.txt	2022-04-30 18:23:57.722732800 -0700
@@ -0,0 +1,90 @@
+build_example(
+  NAME fragmentation-ipv6
+  SOURCE_FILES fragmentation-ipv6.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME fragmentation-ipv6-two-MTU
+  SOURCE_FILES fragmentation-ipv6-two-MTU.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME icmpv6-redirect
+  SOURCE_FILES icmpv6-redirect.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME loose-routing-ipv6
+  SOURCE_FILES loose-routing-ipv6.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME ping6
+  SOURCE_FILES ping6.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME radvd
+  SOURCE_FILES radvd.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME radvd-two-prefix
+  SOURCE_FILES radvd-two-prefix.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME test-ipv6
+  SOURCE_FILES test-ipv6.cc
+  LIBRARIES_TO_LINK ${libpoint-to-point}
+                    ${libinternet}
+)
+
+build_example(
+  NAME wsn-ping6
+  SOURCE_FILES wsn-ping6.cc
+  LIBRARIES_TO_LINK
+    ${liblr-wpan}
+    ${libinternet}
+    ${libsixlowpan}
+    ${libmobility}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME fragmentation-ipv6-PMTU
+  SOURCE_FILES fragmentation-ipv6-PMTU.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+    ${libpoint-to-point}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/ipv6/fragmentation-ipv6-PMTU.cc ns-3.36/examples/ipv6/fragmentation-ipv6-PMTU.cc
--- ns-3.35/examples/ipv6/fragmentation-ipv6-PMTU.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/ipv6/fragmentation-ipv6-PMTU.cc	2022-04-30 18:23:57.722732800 -0700
@@ -0,0 +1,160 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2008-2009 Strasbourg University
+ * Copyright (c) 2013 Universita' di Firenze
+ * Copyright (c) 2022 Jadavpur University
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: David Gross <gdavid.devel@gmail.com>
+ *         Sebastien Vincent <vincent@clarinet.u-strasbg.fr>
+ * Modified by Akash Mondal <a98mondal@gmail.com>
+ */
+
+// Network topology
+// //
+// //      Src  n0        r1     n1      r2        n2
+// //           |         _      |       _         |
+// //           =========|_|============|_|=========
+// //      MTU   5000           2000          1500
+// //
+// // - Tracing of queues and packet receptions to file "fragmentation-ipv6-PMTU.tr"
+
+#include <fstream>
+#include "ns3/core-module.h"
+#include "ns3/network-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/csma-module.h"
+#include "ns3/point-to-point-module.h"
+#include "ns3/internet-apps-module.h"
+#include "ns3/ipv6-static-routing-helper.h"
+
+#include "ns3/ipv6-routing-table-entry.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("FragmentationIpv6PmtuExample");
+
+int
+main (int argc, char **argv)
+{
+  bool verbose = false;
+
+  CommandLine cmd (__FILE__);
+  cmd.AddValue ("verbose", "turn on log components", verbose);
+  cmd.Parse (argc, argv);
+
+  if (verbose)
+    {
+      LogComponentEnable ("Ipv6L3Protocol", LOG_LEVEL_ALL);
+      LogComponentEnable ("Icmpv6L4Protocol", LOG_LEVEL_ALL);
+      LogComponentEnable ("Ipv6StaticRouting", LOG_LEVEL_ALL);
+      LogComponentEnable ("Ipv6Interface", LOG_LEVEL_ALL);
+      LogComponentEnable ("Ping6Application", LOG_LEVEL_ALL);
+    }
+
+  NS_LOG_INFO ("Create nodes.");
+  Ptr<Node> n0 = CreateObject<Node> ();
+  Ptr<Node> r1 = CreateObject<Node> ();
+  Ptr<Node> n1 = CreateObject<Node> ();
+  Ptr<Node> r2 = CreateObject<Node> ();
+  Ptr<Node> n2 = CreateObject<Node> ();
+
+  NodeContainer net1 (n0, r1);
+  NodeContainer net2 (r1, n1, r2);
+  NodeContainer net3 (r2, n2);
+  NodeContainer all (n0, r1, n1, r2, n2);
+
+  NS_LOG_INFO ("Create IPv6 Internet Stack");
+  InternetStackHelper internetv6;
+  internetv6.Install (all);
+
+  NS_LOG_INFO ("Create channels.");
+  CsmaHelper csma;
+  csma.SetChannelAttribute ("DataRate", DataRateValue (5000000));
+  csma.SetChannelAttribute ("Delay", TimeValue (MilliSeconds (2)));
+  csma.SetDeviceAttribute ("Mtu", UintegerValue (2000));
+  NetDeviceContainer d2 = csma.Install (net2);  // CSMA Network with MTU 2000
+
+  csma.SetDeviceAttribute ("Mtu", UintegerValue (5000));
+  NetDeviceContainer d1 = csma.Install (net1);  // CSMA Network with MTU 5000
+
+  PointToPointHelper pointToPoint;
+  pointToPoint.SetDeviceAttribute ("DataRate", DataRateValue (5000000));
+  pointToPoint.SetChannelAttribute ("Delay", StringValue ("2ms"));
+  pointToPoint.SetDeviceAttribute ("Mtu", UintegerValue (1500));
+  NetDeviceContainer d3 = pointToPoint.Install (net3);  // P2P Network with MTU 1500
+
+  NS_LOG_INFO ("Create networks and assign IPv6 Addresses.");
+  Ipv6AddressHelper ipv6;
+
+  ipv6.SetBase (Ipv6Address ("2001:1::"), Ipv6Prefix (64));
+  Ipv6InterfaceContainer i1 = ipv6.Assign (d1);
+  i1.SetForwarding (1, true);
+  i1.SetDefaultRouteInAllNodes (1);
+
+  ipv6.SetBase (Ipv6Address ("2001:2::"), Ipv6Prefix (64));
+  Ipv6InterfaceContainer i2 = ipv6.Assign (d2);
+  i2.SetForwarding (0, true);
+  i2.SetDefaultRouteInAllNodes (0);
+  i2.SetForwarding (1, true);
+  i2.SetDefaultRouteInAllNodes (0);
+  i2.SetForwarding (2, true);
+  i2.SetDefaultRouteInAllNodes (2);
+
+  ipv6.SetBase (Ipv6Address ("2001:3::"), Ipv6Prefix (64));
+  Ipv6InterfaceContainer i3 = ipv6.Assign (d3);
+  i3.SetForwarding (0, true);
+  i3.SetDefaultRouteInAllNodes (0);
+
+  Ipv6StaticRoutingHelper routingHelper;
+  Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper> (&std::cout);
+  routingHelper.PrintRoutingTableAt (Seconds (0), r1, routingStream);
+
+  /* Create a Ping6 application to send ICMPv6 echo request from r to n2 */
+  uint32_t packetSize = 1600; // Packet should fragment as intermediate link MTU is 1500
+  uint32_t maxPacketCount = 5;
+  Time interPacketInterval = Seconds (1.0);
+  Ping6Helper ping6;
+
+  ping6.SetLocal (i2.GetAddress (1, 1));
+  ping6.SetRemote (i3.GetAddress (1, 1));
+
+  ping6.SetAttribute ("MaxPackets", UintegerValue (maxPacketCount));
+  ping6.SetAttribute ("Interval", TimeValue (interPacketInterval));
+  ping6.SetAttribute ("PacketSize", UintegerValue (packetSize));
+  ApplicationContainer apps = ping6.Install (n1);
+  apps.Start (Seconds (2.0));
+  apps.Stop (Seconds (10.0));
+
+  /* Create a Ping6 application to send ICMPv6 echo request from n0 to n2 */
+  packetSize = 4000;
+  ping6.SetAttribute ("PacketSize", UintegerValue (packetSize));
+
+  ping6.SetLocal (i1.GetAddress (0, 1));
+  ping6.SetRemote (i3.GetAddress (1, 1));
+  apps = ping6.Install (n0);
+  apps.Start (Seconds (11.0));
+  apps.Stop (Seconds (20.0));
+
+  AsciiTraceHelper ascii;
+  csma.EnableAsciiAll (ascii.CreateFileStream ("fragmentation-ipv6-PMTU.tr"));
+  csma.EnablePcapAll (std::string ("fragmentation-ipv6-PMTU"), true);
+  pointToPoint.EnablePcapAll (std::string ("fragmentation-ipv6-PMTU"), true);
+
+  NS_LOG_INFO ("Run Simulation.");
+  Simulator::Run ();
+  Simulator::Destroy ();
+  NS_LOG_INFO ("Done.");
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/ipv6/test-ipv6.cc ns-3.36/examples/ipv6/test-ipv6.cc
--- ns-3.35/examples/ipv6/test-ipv6.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/ipv6/test-ipv6.cc	2022-04-30 18:23:57.722732800 -0700
@@ -23,6 +23,7 @@
 #include "ns3/ipv6-address.h"
 #include "ns3/node.h"
 #include "ns3/mac48-address.h"
+#include "ns3/simulator.h"
 
 using namespace ns3;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/matrix-topology/CMakeLists.txt ns-3.36/examples/matrix-topology/CMakeLists.txt
--- ns-3.35/examples/matrix-topology/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/matrix-topology/CMakeLists.txt	2022-04-30 18:23:57.722732800 -0700
@@ -0,0 +1,11 @@
+build_example(
+  NAME matrix-topology
+  SOURCE_FILES matrix-topology.cc
+  LIBRARIES_TO_LINK
+    ${libnetwork}
+    ${libnetanim}
+    ${libmobility}
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/naming/CMakeLists.txt ns-3.36/examples/naming/CMakeLists.txt
--- ns-3.35/examples/naming/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/naming/CMakeLists.txt	2022-04-30 18:23:57.722732800 -0700
@@ -0,0 +1,9 @@
+build_example(
+  NAME object-names
+  SOURCE_FILES object-names.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/realtime/CMakeLists.txt ns-3.36/examples/realtime/CMakeLists.txt
--- ns-3.35/examples/realtime/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/realtime/CMakeLists.txt	2022-04-30 18:23:57.722732800 -0700
@@ -0,0 +1,10 @@
+if(${ENABLE_REALTIME})
+  build_example(
+    NAME realtime-udp-echo
+    SOURCE_FILES realtime-udp-echo.cc
+    LIBRARIES_TO_LINK
+      ${libcsma}
+      ${libinternet}
+      ${libapplications}
+  )
+endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/routing/CMakeLists.txt ns-3.36/examples/routing/CMakeLists.txt
--- ns-3.35/examples/routing/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/routing/CMakeLists.txt	2022-04-30 18:23:57.722732800 -0700
@@ -0,0 +1,133 @@
+build_example(
+  NAME dynamic-global-routing
+  SOURCE_FILES dynamic-global-routing.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME static-routing-slash32
+  SOURCE_FILES static-routing-slash32.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME global-routing-slash32
+  SOURCE_FILES global-routing-slash32.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME global-injection-slash32
+  SOURCE_FILES global-injection-slash32.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME simple-global-routing
+  SOURCE_FILES simple-global-routing.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+    ${libflow-monitor}
+)
+
+build_example(
+  NAME simple-alternate-routing
+  SOURCE_FILES simple-alternate-routing.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME mixed-global-routing
+  SOURCE_FILES mixed-global-routing.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libcsma}
+    ${libapplications}
+)
+
+build_example(
+  NAME simple-routing-ping6
+  SOURCE_FILES simple-routing-ping6.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME manet-routing-compare
+  SOURCE_FILES manet-routing-compare.cc
+  LIBRARIES_TO_LINK
+    ${libwifi}
+    ${libdsr}
+    ${libdsdv}
+    ${libaodv}
+    ${libolsr}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME ripng-simple-network
+  SOURCE_FILES ripng-simple-network.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME rip-simple-network
+  SOURCE_FILES rip-simple-network.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libinternet-apps}
+)
+
+build_example(
+  NAME global-routing-multi-switch-plus-router
+  SOURCE_FILES global-routing-multi-switch-plus-router.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libnetwork}
+    ${libapplications}
+    ${libinternet}
+    ${libbridge}
+    ${libcsma}
+    ${libpoint-to-point}
+    ${libcsma}
+    ${libinternet}
+)
+
+build_example(
+  NAME simple-multicast-flooding
+  SOURCE_FILES simple-multicast-flooding.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libnetwork}
+    ${libapplications}
+    ${libinternet}
+)
